class_name BaseInventorySlot
extends TextureRect

# given by container
@export var inventory_data: InventoryDataResource
@export var quantity_label: Label

# set the inventory data
func set_inventory_data(inv_data: InventoryDataResource) -> void:
	push_error("function was unimplemented")

# refresh the state of item in the slot, need to be called by and connected to a signal from container 
func refresh_item_stack_data() -> void:
	push_error("function was unimplemented")

# get item data from the slot
func get_item_data() -> ItemResource:
	push_error("function was unimplemented")
	return null

# get item stack data from the slot
func get_item_stack_data() -> ItemStackResource:
	push_error("function was unimplemented")
	return null

# set item stack data for the slot
func set_item_stack_data(item: ItemStackResource) -> void:
	push_error("function was unimplemented")

# check if can drop item to this slot, 
func can_drop_item(item: ItemStackResource) -> bool:
	push_error("function was unimplemented")
	return false

func _can_drop_data(_position: Vector2, data: Variant) -> bool:
	var source_inv_slot := data as BaseInventorySlot
	var source_item := source_inv_slot.get_item_stack_data()
	var dest_item := self.get_item_stack_data()
	return source_inv_slot.can_drop_item(dest_item) && self.can_drop_item(source_item)

func show_item_quantity_label(item_stack: ItemStackResource) -> bool:
	return item_stack and item_stack.quantity > 1
