class_name MaterialSlot
extends TextureRect


@onready var item_texture: TextureRect = $ItemTexture
@onready var quantity_label: Label = $QuantityLabel


func initialize(item_quantity: ItemQuantity) -> void:
	var item_res: ItemResource = ItemDatabase.get_item(item_quantity.item_id)
	quantity_label.text = str(item_quantity.quantity)
	if is_instance_valid(item_res):
		item_texture.texture = item_res.icon
	else:
		quantity_label.text = "X"
