class_name EquipmentContainer
extends GridContainer

@export var inventory_data: InventoryDataResource

var _slots: Array[EquipmentSlot] = []

func _ready() -> void:
	if not inventory_data:
		inventory_data = InventoryDataResource.new()
	
	setup_slot()
	
	inventory_data.equipment_changed.connect(
		func(slot_index: int) -> void:
			print("equipment_changed %d" % slot_index)
			_slots[slot_index].refresh_item_stack_data()
	)


func _check_children_type() -> void:
	assert(_slots.size() == inventory_data.EQUIPMENT_CAPACITY, "Wrong number of item slot")	
	for index in range(inventory_data.EQUIPMENT_CAPACITY):
		assert(_slots[index].equipment_index == index, "Wrong index for slot %d" % [index])

func setup_slot() -> void:
	for child in get_children():
		_slots.append(child)
	
	_check_children_type()
	
	for index in range(inventory_data.EQUIPMENT_CAPACITY):
		_slots[index].set_inventory_data(inventory_data)
		_slots[index].refresh_item_stack_data()
