class_name HotbarContainer
extends HBoxContainer


@export var inventory_data: InventoryDataResource


var _slots: Array[HotbarSlot] = []


func _ready() -> void:
	if not inventory_data:
		inventory_data = Singletons.inventory_data_resource
	
	setup_slot()
	
	inventory_data.hotbar_changed.connect(
		func(slot_index: int) -> void:
			#print("hotbar_changed %d" % slot_index)
			_slots[slot_index].refresh()
	)
	inventory_data.update_all.connect(
		func() -> void:
			for slot in _slots:
				slot.refresh_item_stack_data()
	)


func _check_children_type() -> void:
	assert(_slots.size() == inventory_data.HOTBAR_CAPACITY, "Wrong number of item slot")	
	for index in range(inventory_data.HOTBAR_CAPACITY):
		assert(_slots[index].hotbar_index == index, "Wrong index for slot %d" % [index])

func setup_slot() -> void:
	for child in get_children():
		_slots.append(child)
	
	_check_children_type()
	
	for index in range(inventory_data.HOTBAR_CAPACITY):
		_slots[index].set_inventory_data(inventory_data)
