class_name InventoryGrid
extends GridContainer


@export var inventory_data: InventoryDataResource

var _slots: Array[InventorySlot] = []


func _ready() -> void:
	if not inventory_data:
		inventory_data = Singletons.inventory_data_resource
	
	setup_slot()
	
	inventory_data.slot_changed.connect(
		func(slot_index: int) -> void:
			print("slot_changed %d" % slot_index)
			_slots[slot_index].update_item_stack_data()
	)
	inventory_data.update_all.connect(
		func() -> void:
			for slot in _slots:
				slot.refresh_item_stack_data()
	)


func _check_children_type() -> void:
	assert(_slots.size() == inventory_data.ITEM_CAPACITY, "Wrong number of item slot")	
	for index in range(inventory_data.ITEM_CAPACITY):
		assert(_slots[index].slot_index == index, "Wrong index for slot %d" % [index])


func setup_slot() -> void:
	for child in get_children():
		_slots.append(child)
	
	_check_children_type()
	
	for index in range(inventory_data.ITEM_CAPACITY):
		_slots[index].inventory_data = inventory_data
		_slots[index].update_item_stack_data()
