extends Area2D

class_name Hitbox

## REMINDER: ALWAYS INSTANTIATE THIS SCENE (THE CHAIN ICON) IF YOU WANT TO USE IT, DON'T ADD CHILD NODE (THE PLUS ICON)!


signal hurtbox_detected(hurtbox: Hurtbox)
signal hurtbox_undetected(hurtbox: Hurtbox)

@export var team := Hurtbox.Team.NONE

# Actor will give their stats to this hitbox in _ready()
var actor_stats: ActorStats

var _detected_hurtbox: Array[Hurtbox] = []


func try_hurt() -> bool:
	if _detected_hurtbox.is_empty():
		return false
	
	for hurtbox in _detected_hurtbox:
		if hurtbox.team != team and hurtbox.hurt(actor_stats):
			return true
	
	return false


func _on_area_entered(hurtbox: Hurtbox) -> void:
	if hurtbox.team == team:
		return
	
	_detected_hurtbox.append(hurtbox)
	hurtbox_detected.emit(hurtbox)


func _on_area_exited(hurtbox: Hurtbox) -> void:
	if hurtbox.team == team:
		return
	
	_detected_hurtbox.erase(hurtbox)
	hurtbox_undetected.emit(hurtbox)
