extends Node2D


const ENEMY_ESCALATE_SCNS := [
	[
		preload("res://objects/characters/enemies/slime.tscn"),
	],
	[
		preload("res://objects/characters/enemies/bat.tscn"),
		preload("res://objects/characters/enemies/ranged_enemy.tscn"),
	],
	[
		preload("res://objects/characters/enemies/medium_bat.tscn"),
		preload("res://objects/characters/enemies/medium_ranged_enemy.tscn"),
	],
	[
		preload("res://objects/characters/enemies/hard_bat.tscn"),
		preload("res://objects/characters/enemies/hard_ranged_enemy.tscn"),
	],
]

const MAX_ENEMY := 20

@export var player: Grovekeeper

var _escalation_level := -1
var _possible_enemy_scns: Array[PackedScene] = []


func _on_spawn_timer_timeout() -> void:
	if _possible_enemy_scns.size() <= 0:
		return
	
	var enemy_scn: PackedScene = _possible_enemy_scns.pick_random() as PackedScene
	var enemy: Actor = enemy_scn.instantiate() as Actor
	enemy.tracked_player = player
	enemy.global_position = global_position
	enemy.global_position.x = player.global_position.x + randf_range(500, 1000) * (randi_range(0, 1) * 2 - 1)
	add_child(enemy)


func _on_escalate_timer_timeout() -> void:
	_escalation_level += 1
	
	if _escalation_level < ENEMY_ESCALATE_SCNS.size():
		_possible_enemy_scns.append_array(ENEMY_ESCALATE_SCNS[_escalation_level])
	
	#printt("ESCALATE", _escalation_level, _possible_enemy_scns)
