extends CharacterBody2D

class_name Projectile


@export var speed = 500.0

@export var _hitbox: Hitbox


func initialize(g_pos: Vector2, g_rot: float, actor_stats: ActorStats, team: Hurtbox.Team) -> void:
	global_position = g_pos
	global_rotation = g_rot
	velocity = Vector2.RIGHT.rotated(global_rotation) * speed
	_hitbox.actor_stats = actor_stats
	_hitbox.team = team
	
	printt(global_position, global_rotation)


func _physics_process(delta: float) -> void:
	if move_and_slide():
		print("collide")
		queue_free()


func _on_hitbox_hurtbox_detected(_hurtbox: Hurtbox) -> void:
	if _hitbox.try_hurt():
		print("hitbox")
		queue_free()


func _on_despawn_timer_timeout() -> void:
	print("timer")
	queue_free()
