extends Resource

class_name ActorStats


signal hp_changed()
signal died()

@export var max_hp := 100
@export var hp := 100
@export var damage := 10
@export var def := 0

var equipment_def := 0


func recalculate_equipment_stats(equipments: Array[ItemStackResource]) -> void:
	equipment_def = 0 
	for equipment in equipments:
		if equipment && equipment.item_res:
			equipment_def += equipment.item_res.def
	print('new def from equipment %d' % [equipment_def])


func heal(heal: int) -> void:
	hp += heal
	hp = clampi(hp, 0, max_hp)
	hp_changed.emit()


func process_damage(other_damage: int) -> void:
	# TODO: handle def from damage
	hp -= other_damage
	hp = clampi(hp, 0, max_hp)
	hp_changed.emit()
	
	if hp <= 0:
		died.emit()
