#Still in test
extends Node2D
class_name Harvestable

@export_file("*.tscn") var fruit
@export_file() var wood
@export_file() var seed
@export var fruit_count: int
@export var wood_count: int
@export var seed_count: int
@onready var sprite = $Sprite2D

# Called when the node enters the scene tree for the first time.
func _ready():
	# Connect the hit signal to the function
	connect("input_event", Callable(self, "_on_hit_by_axe"))

# Called every frame. 'delta' is the elapsed time since the previous frame.
func _process(delta):
	pass

func _on_input_event(viewport, event, shape_idx):
	if event is InputEventMouseButton and event.pressed:
		var inventory = get_tree().root.get_node("")  # Adjust path to your Inventory node
		if inventory:
			var current_item = inventory.get_current_item()
			if current_item and current_item is InventorySlot and current_item.get_item_name() == "Axe":
				harvest()
				inventory.remove_current_item()

func harvest():
	emit_signal("harvested")
	_drop_items()
	queue_free()

# Function to handle dropping the items
func _drop_items():
	var parent = get_parent()
	
	# Drop fruit
	if fruit != "":
		for i in range(fruit_count):
			var fruit_instance = load(fruit).instantiate()
			fruit_instance.position = position
			parent.add_child(fruit_instance)

	# Drop wood
	for i in range(wood_count):
		var wood_instance = load(wood).instantiate()
		# Customize wood_instance as needed, e.g., setting a sprite or other properties
		wood_instance.position = position
		parent.add_child(wood_instance)

	# Drop seed
	if seed != "":
		for i in range(seed_count):
			var seed_instance = load(seed).instantiate()
			seed_instance.position = position
			parent.add_child(seed_instance)
