class_name ItemResource
extends Resource


@export var icon: Texture2D = null : get = _get_item_icon, set = _set_item_icon
@export var name: String = "ItemResource" : get = _get_item_name, set = _set_item_name
@export var id: String = "ID" : get = _get_item_id, set = _set_item_id
@export var def: float = 0.0 : get = _get_item_def, set = _set_item_def
@export var max_stack: int = 64 : get = _get_item_max_stack, set = _set_item_max_stack

@export_enum("Crafting Material", "Tool", "Equipment", "Seed")
var type : String = "Crafting Material"

@export_multiline var description : String = "Desc" : get = _get_item_desc, set = _set_item_desc


# HACK: Dictionary might be expensive but who cares at this point lol. Only player use this anyway.
func use_item(data: Dictionary) -> Dictionary:
	return {}

func _set_item_icon(new_value : Texture2D) -> void:
	icon = new_value

func _set_item_name(new_value : String) -> void:
	name = new_value
	
func _set_item_id(new_value : String) -> void:
	id = new_value

func _set_item_desc(new_value : String) -> void:
	description = new_value

func _set_item_def(new_value : float) -> void:
	def = new_value

func _set_item_max_stack(new_value : int) -> void:
	max_stack = new_value

func _get_item_icon() -> Texture2D:
	return icon

func _get_item_name() -> String:
	return name

func _get_item_id() -> String:
	return id

func _get_item_desc() -> String:
	return description

func _get_item_def() -> float:
	return def

func _get_item_max_stack() -> int:
	return max_stack
