class_name ItemStackResource
extends Resource


@export var item_res: ItemResource
@export var quantity: int


func init_stack(p_item: ItemResource, p_quantity: int) -> void:
	item_res = p_item
	quantity = p_quantity


func interact(data: Dictionary) -> Dictionary:
	var ret_data := {}
	if quantity <= 0:
		push_error("item stack quantity was zero but it is still been interacted")
	if item_res:
		ret_data = item_res.use_item(data)
		
		quantity -= ret_data.get("quantity_used", 0)
	
	return ret_data


func add_to_stack(item: ItemResource, add_quantity: int) -> bool:
	if quantity + add_quantity < item.max_stack:
		return 0
	return quantity + add_quantity - item.max_stack

# TODO: implement max quantity of a stack
