class_name SeedItemResource
extends ItemResource


const PLANT_SCN := preload("res://objects/structures/plant.tscn")

@export var plant_data: PlantDataResource


func use_item(data: Dictionary) -> Dictionary:
	# HACK: Cyclic reference so don't static typing here
	var build_controller = data.get("build_controller")
	var success := false
	
	if is_instance_valid(build_controller):
		# HACK: Cyclic reference so don't static typing here
		var plant = PLANT_SCN.instantiate()
		plant.plant_data = plant_data
		success = build_controller.place_building_at_mouse(plant, true)
	
	return {
		"use_success" : success,
		"quantity_used" : int(success),
	}
