class_name Pickupable
extends Area2D


signal insert_to_inventory(item_resource : ItemResource)

@export var item_stack_res: ItemStackResource : set = set_item_stack_res
@export var sprite: Sprite2D
@export var quantity_label: Label
@onready var sfx: AudioStreamPlayer2D = $AudioStreamPlayer2D
@onready var collision: CollisionShape2D = $CollisionShape2D

#var stats: ItemResource = null:
	#set (value):
		#stats = value
		#
		#if value != null:
			#sprite.texture = value.icon


#func _ready() -> void:
	#if is_instance_valid(item_stack_res):
		#set_item_stack_res(item_stack_res)


func set_item_stack_res(value: ItemStackResource) -> void:
	item_stack_res = value
	sprite.texture = item_stack_res.item_res.icon
	quantity_label.text = str(item_stack_res.quantity)


func collect(inventory : InventoryDataResource) -> void:
	var item: ItemResource = item_stack_res.item_res.duplicate()
	item._set_item_name(item_stack_res.item_res.name)
	item._set_item_desc(item_stack_res.item_res.description)
	item._set_item_icon(item_stack_res.item_res.icon)
	var result := inventory.insert_item_to_inventory(item, item_stack_res.quantity)
	if result:
		# To Be Discussed, only delete when it is added to inventory
		sfx.play()
		collision.call_deferred("set", "disabled", true)
		sprite.visible = false


#func insert_into_inventory(item: ItemResource, inventory : InventoryDataResource):
#	var item_resource : ItemResource = ItemResource.new()
#	item_resource.id = item.id
#	item_resource._set_item_name(item._get_item_name())
#	item_resource._set_item_desc(item._get_item_desc())
#	item_resource._set_item_icon(item._get_item_icon())
#	return inventory.insert_item_to_inventory(item_resource)


func _on_audio_stream_player_2d_finished():
	queue_free()
