extends Node2D


@export_dir var item_folder: String

var items: Dictionary = {}


# TODO: change to access files directly (FileAccess) since it doesn't work after exporting
func _ready() -> void:
	var folder = DirAccess.open(item_folder)
	folder.list_dir_begin()
	var file_name := folder.get_next()
	while file_name != "":
		if file_name.substr(file_name.length() - 5) == ".tres":
			var item_id := file_name.substr(0, file_name.length() - 5)
			items[item_id] = load(item_folder + "/" + file_name)
		file_name = folder.get_next()
	folder.list_dir_end()


func get_item(ID: String) -> ItemResource:
	if items.has(ID):
		return items[ID]
	else:
		return null
