extends RigidBody2D


signal insert_to_inventory(item_resource : ItemResource)

@onready var sprite = $Sprite2D
@onready var collision = $CollisionShape2D
@onready var sound = $AudioStreamPlayer2D
@export var amount = 1
@export var item_id: String

var speed = 0
var target = null

var stats: ItemResource = null:
	set (value):
		stats = value
		
		if value != null:
			sprite.texture = value.icon


func _ready():
	stats = ItemDatabase.get_item(item_id)


func _physics_process(delta):
	if target != null:
		global_position = global_position.move_toward(target.global_position, speed)


func collect(inventory : Resource):
	var item : ItemResource = stats.duplicate() as ItemResource
	#item._set_item_name(stats.name)
	#item._set_item_desc(stats.description)
	#item._set_item_icon(stats.icon)
	var result = inventory.insert_item_to_inventory(item, amount)
	if result == true:
		# To Be Discussed, only delete when it is added to inventory
		sound.play()
		collision.call_deferred("set", "disabled", true)
		sprite.visible = false
	print(result)
	return amount


#func insert_into_inventory(item: ItemResource, inventory : InventoryDataResource):
#	var item_resource : ItemResource = ItemResource.new()
#	item_resource.id = item.id
#	item_resource._set_item_name(item._get_item_name())
#	item_resource._set_item_desc(item._get_item_desc())
#	item_resource._set_item_icon(item._get_item_icon())
#	return inventory.insert_item_to_inventory(item_resource)


func _on_audio_stream_player_2d_finished():
	queue_free()
